<?php
/*************************
  Coppermine Photo Gallery
  ************************
  Copyright (c) 2003-2005 Coppermine Dev Team
  v1.1 originaly written by Gregory DEMAR

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  ********************************************
  Coppermine version: 1.4.2
  $Source: /cvsroot/coppermine/devel/login.php,v $
  $Revision: 1.26 $
  $Author: gaugau $
  $Date: 2005/10/25 01:15:42 $
**********************************************/

define('IN_COPPERMINE', true);
define('LOGIN_PHP', true);

require('include/init.inc.php');

if (defined('UDB_INTEGRATION')) $cpg_udb->login_page();

$login_failed = '';
$cookie_warning = '';

// extract GET parameters
$referrer = $_GET['referrer'];
if (empty($referrer)) {
	print "Invalid request. Consult a manual.";
}
$referrer=preg_replace("'&amp;'","&",$referrer);

$user_id=addslashes($_GET['user']);
$randnum=addslashes($_GET['session']);

// get session id
$client_id = md5($_SERVER['HTTP_USER_AGENT'].$_SERVER['SERVER_PROTOCOL'].$CONFIG['site_url']);
$session_id = $randnum.$client_id;

$cpg_udb->client_id = $client_id;
$cpg_udb->session_id = $randnum;

// set the cookie
setcookie( $cpg_udb->client_id, $cpg_udb->session_id, time() + (CPG_WEEK*2), $CONFIG['cookie_path'] );

// set header to redirect back to WordPress
pageheader($lang_login_php['login'], "<META http-equiv=\"refresh\" content=\"3;url=$referrer\">");

// handle logout
if (USER_ID && isset($_GET['action']) && $_GET['action']=='logout')
{
	$cpg_udb->logout();
} 

// handle login
else {
	
	if (!USER_ID && !empty($user_id) && !empty($session_id)) {

		$USER_DATA=wp_login($user_id, $session_id);
		
		if (!$USER_DATA) {
			wp_logfailure();
		}
	} 
}

// return $USER_DATA on success
function wp_login($user_id, $session_id)
{
	global $cpg_udb;
	global $CONFIG;
	
	// verify that GET parameters are found in the sessions table
	$sql =  "SELECT COUNT(*) FROM {$cpg_udb->sessionstable} WHERE ".
			"session_id = md5('$session_id') AND ".
			"user_id = '$user_id'";
	$result = cpg_db_query($sql);
	$values = mysql_fetch_row($result);

	mysql_free_result($result);
	if ($values[0]==0) {
		return false;
	}
	// get login info from users table
	$sql =  "SELECT user_id, user_name, user_password FROM {$cpg_udb->usertable} WHERE ".
			"user_id = '$user_id' AND user_active = 'YES'";
	$results = cpg_db_query($sql);
	if (0==mysql_num_rows($results)) {
		return false;
	}

	$user = mysql_fetch_assoc($results);
	mysql_free_result($results);

	// call login function
	$USER_DATA = $cpg_udb->login( $user['user_name'], $user['user_password'], false );
	return $USER_DATA;
}

// write login attempts to log, and ban user if max attempts exceeded
function wp_logfailure()
{
	print "the error !";
	exit;
	
	global $lang_login_php;
	global $CONFIG;
	
	log_write("Failed login attempt with Username: {$_POST['username']} from IP {$_SERVER['REMOTE_ADDR']} on " . localised_date(-1,$log_date_fmt),CPG_SECURITY_LOG);

	$login_failed = <<<EOT
	<tr>
	<td colspan="2" align="center" class="tableh2">
	<font size="1" color="red"><b>{$lang_login_php['err_login']}<b></font>
	</td>
	</tr>
EOT;

	// get IP address of the person who tried to log in, look it up on the banning table and increase the brute force counter. If the brute force counter has reached a critical limit, set a regular banning record
	$result = cpg_db_query("SELECT * FROM {$CONFIG['TABLE_BANNED']} WHERE ip_addr='$raw_ip' OR ip_addr='$hdr_ip'");
	$failed_logon_counter = mysql_fetch_array($result);
	mysql_free_result($result);
	$expiry_date = date("Y-m-d H:i:s", mktime(date('H'), date('i')+$CONFIG['login_expiry'], date('s'), date('m'), date('d'),date('Y')));

	if ($failed_logon_counter['brute_force']) {
		$failed_logon_counter['brute_force'] = $failed_logon_counter['brute_force'] - 1;
		$query_string = "UPDATE {$CONFIG['TABLE_BANNED']} SET brute_force='".$failed_logon_counter['brute_force']."',  expiry='".$expiry_date."' WHERE ban_id=".$failed_logon_counter['ban_id'];
	}else{
		$failed_logon_counter['brute_force'] = $CONFIG['login_threshold'];
		$query_string = "INSERT INTO {$CONFIG['TABLE_BANNED']} (ip_addr, expiry, brute_force) VALUES ('$raw_ip', '$expiry_date','".$failed_logon_counter['brute_force']."')";
	}

	//write the logon counter to the database
	cpg_db_query($query_string);
}

?>
<html>
	<head>
		<title>WP-Login</title>
		<script type="text/javascript">
			location.replace("<?php echo $referrer; ?>");
		</script>
	</head>
	<body>This page should take you back to <?php echo htmlspecialchars($referrer); ?>. If is doesn't do so automatically, please click <a href="<?php echo $referrer; ?>" onclick="window.replace('<?php echo $referrer; ?>');">this link</a> to continue.<br/>
	</body>
</html>
