<?php get_header(); ?>

<?
	if(is_search()) {
		/* search for pictures */
		$search = $wp_query->get('s');
		$keywords = preg_replace('/\+/',' ',$search);

		/* get albums */
		$albums = cpg_db_search_albums($keywords);

		/* get images */
		$pictures = cpg_db_search_pictures($keywords);
	}
?>

	<div id="content" class="narrowcolumn">

	<?php if (have_posts() || $pictures || $albums) : ?>

		<h2 class="pagetitle">Search Results</h2>
		
		<div class="navigation">
			<div class="alignleft"><?php next_posts_link('&laquo; Previous Entries') ?></div>
			<div class="alignright"><?php previous_posts_link('Next Entries &raquo;') ?></div>
		</div>

	<?  /* display albums */
		$count=0;
		if ($albums) {
			print '<h3>Albums</h3>';
			foreach ($albums as $aid) {
				print '<div class="cpg-search-album">'.cpg_get_album($aid,1,false).'</div>';
				if ($count) {
					print "<br/>";
				}
				++$count;
				$count%=2;
			}
			print  '<div class="clearer">&nbsp;</div>';
		}

	
		/* display images */
		$count=0;
		if ($pictures) {
			print '<h3>Pictures</h3>';
			foreach ($pictures as $pid) {
				print '<div class="cpg-search-image">'.cpg_get_thumbnail_absolute($pid).'</div>';
				if ($count) {
					print "<br/>";
				}
				++$count;
				$count%=2;
			}
			print  '<div class="clearer">&nbsp;</div>';
		}

	?>


		<?php while (have_posts()) : the_post(); ?>
				
			<div class="post">
				<h3 id="post-<?php the_ID(); ?>"><a href="<?php the_permalink() ?>" rel="bookmark" title="Permanent Link to <?php the_title(); ?>"><?php the_title(); ?></a></h3>
				<small><?php the_time('L, F jS, Y') ?> <!-- by <?php the_author() ?> --> </small> 
				
				<div class="entry">
					<?php the_excerpt() ?>
				</div>
		
				<p class="postmetadata">Posted in <?php the_category(', ') ?> <strong>|</strong> <?php edit_post_link('Edit','','<strong>|</strong>'); ?>  <?php comments_popup_link('No Comments &#187;', '1 Comment &#187;', '% Comments &#187;'); ?></p>
			</div>
	
		<?php endwhile; ?>

		<div class="navigation">
			<div class="alignleft"><?php next_posts_link('&laquo; Previous Entries') ?></div>
			<div class="alignright"><?php previous_posts_link('Next Entries &raquo;') ?></div>
		</div>
	
	<?php else : ?>

		<h2 class="center">Not Found</h2>
		<?php include (TEMPLATEPATH . '/searchform.php'); ?>

	<?php endif; ?>
		
	</div>

<?php get_sidebar(); ?>

<?php get_footer(); ?>
