<?php
/*************************************************************

  Coppermine Photo Gallery
  ************************

  Set cookies for login. Designed to be used with WordPress. 
  This is part of stilgar's Coppermine integration plugin.
 
  Copyright (c) 2005 Martijn van der Kwast

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

**************************************************************/

define('IN_COPPERMINE', true);
define('DB_INPUT_PHP', true);
define('CONFIG_PHP', true);

require('include/init.inc.php');

$referrer=urldecode($_GET['referrer']);

// logout and quit 
if (isset($_GET['action']) && $_GET['action']=='logout') {
	setcookie($CONFIG['cookie_name'] . '_pass', '', time()-86400, $CONFIG['cookie_path']);
	setcookie($CONFIG['cookie_name'] . '_uid', '', time()-86400, $CONFIG['cookie_path']);
//	header('Location: '.$referrer);
//	exit;
}

// login and reload page if we must
else if (isset($_GET['user']) && isset($_GET['pass'])) {
	$cookie_life_time = 86400;
	setcookie($CONFIG['cookie_name'] . '_uid', $_GET['user'], time() + $cookie_life_time, $CONFIG['cookie_path']);
	setcookie($CONFIG['cookie_name'] . '_pass', $_GET['pass'], time() + $cookie_life_time, $CONFIG['cookie_path']);
//	header('Location: '.$referrer);
} 
?><html>
	<head>
		<title>WP-Login</title>
		<script type="text/javascript">
			<?php
				if (isset($_GET['action']) && $_GET['action']=='logout') {
			?>
					var date = new Date();
					date.setTime(date.getTime()-(1*24*60*60*1000));
					var expires = "expires="+date.toGMTString();
					document.cookie = "<?php echo $CONFIG['cookie_name'].'_uid'; ?>=; "+expires+"; path=/";
					document.cookie = "<?php echo $CONFIG['cookie_name'].'_pass'; ?>=; "+expires+"; path=/";
					location.replace("<?php echo $referrer; ?>");
			<?php
				}	
				else if (isset($_GET['user']) && isset($_GET['pass'])) {
			?>
					var date = new Date();
					date.setTime(date.getTime()+(1*24*60*60*1000));
					var expires = "expires="+date.toGMTString();
					document.cookie = "<?php echo $CONFIG['cookie_name'].'_uid='.$_GET['user']; ?>; "+expires+"; path=/";
					document.cookie = "<?php echo $CONFIG['cookie_name'].'_pass='.$_GET['pass']; ?>; "+expires+"; path=/";
					location.replace("<?php echo $referrer; ?>");
			<?php
				}
			?>
		</script>
	</head>
	<body>
<?php
				if (isset($_GET['action']) && $_GET['action']=='logout' ||
				    isset($_GET['user']) && isset($_GET['pass'])) 
				{
?>
This page should take you back to <?php echo htmlspecialchars($referrer); ?>. If is doesn't do so automatically, please click <a href="<?php echo $referrer; ?>" onclick="window.replace('<?php echo $referrer; ?>');">this link</a> to continue.<br/>
<?php
				} else {
?>
There is nothing to see here. You could go <a href="index.php">Here</a> instead. 
<?php
				}
?>
	</body>
</html>
